/*
 * SPI.c
 *
 *  Created on: 14.03.2012
 *      Author: darkhedie
 */


#include "SPI.h"


void lib_clk_delay(uint32_t clk_delay)
{
	clk_delay = clk_delay * 10;
	while(clk_delay--);
}

void lib_spi_cs(uint8_t state)
{
	if(state) GPIO_SetBits(GPIOA,GPIO_Pin_4);
	else GPIO_ResetBits(GPIOA,GPIO_Pin_4);
}


void init_spi(SPI_TypeDef* SPIx, uint16_t Prescaler)
{
	SPI_Cmd(SPIx, DISABLE);
	SPI_I2S_DeInit(SPIx);
	SPI_InitTypeDef   SPI_InitStructure;
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = Prescaler;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPIx, &SPI_InitStructure);
	SPI_Cmd(SPIx, ENABLE);
}


void write_spi (SPI_TypeDef* SPIx, unsigned char data_out)
{       //msb first
	SPI_I2S_SendData(SPIx,data_out);
	while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_BSY) == SET);
}

unsigned char read_spi (SPI_TypeDef* SPIx)
{       //msb first
	write_spi(SPIx,0xFF);
	while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_BSY) == SET);
	while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
	return SPI_I2S_ReceiveData(SPIx);
}






