/*
 * UART.h
 *
 *  Created on: 15.03.2012
 *      Author: darkhedie
 */

#ifndef UART_H_
#define UART_H_

#define BAUD 38400

#define RX	 1
#define TX	 2
#define RXTX 3
#define CLR  4


#define _USE_PUTSTRING	1
#define _USE_PUTCHAR	1
#define _USE_HEX		0
#define	_USE_VAR		1
#define _USE_GETCHAR	0

#if _USE_HEX
void uart_send_as_hex(unsigned char ucNumber);
#endif

#if _USE_VAR
void uart_send_var(unsigned char ucNumber);
#endif

void lib_uart_init(void );
void uart_init_interrupt(unsigned char ucMode);

#if _USE_PUTCHAR
void uart_putc(unsigned char c);
#endif

#if _USE_GETCHAR
unsigned char uart_getc(void);
#endif

#if _USE_PUTSTRING
void uart_puts (char *s);
void uart_puts_size (char *s, unsigned int size);
#endif

#endif /* UART_H_ */
